# log-n-roll

Крошечный <1kb логгер с тонким api и возможностью неограниченного расширения

[![NPM version](https://img.shields.io/npm/v/log-n-roll.svg?style=flat-square)](https://www.npmjs.com/package/log-n-roll)[![Build Status](https://img.shields.io/travis/kutuluk/log-n-roll/master.svg?style=flat-square)](https://travis-ci.org/kutuluk/log-n-roll)

- **Tiny:** меньше килобайта в архиве gzip
- **Pluggable:** один встроенный плагин для приятного форматирования и неограниченные возможности для расширения

## Note

**Этот пакет является Proof-of-Concept и должен восприниматься как нестабильный. Тем не менее, основная идея подтверждена. Релиз состоится.**

## Install

Этот проект использует [node](http://nodejs.org) и [npm](https://npmjs.com). Удостоверьтесь, что они установлены.

```sh
$ npm install log-n-roll
```

Со сборщиками бандлов наподобие [rollup](http://rollupjs.org/) или [webpack](https://webpack.js.org/) следует использовать один из следующих синтаксисов:

```javascript
// using ES6 modules
import log from 'log-n-roll';

// using CommonJS modules
var log = require('log-n-roll');
```

Сборка [UMD](https://github.com/umdjs/umd) доступна на [unpkg](https://unpkg.com):

```html
<script src="https://unpkg.com/log-n-roll/dist/log-n-roll.umd.js"></script>
```

После этого Вы сможете найти бибилиотеку в `window.log`.

## Основные концепции логгера

- Этот логгер нацелен на использование в браузерах. Поэтому размер имеет значение и он должен быть настолько маленьким, насколько возможно. Из коробки логгер обеспечивает лишь базовую функциональность, предоставляя систему плагинов для расширения.

- Несмотря на приоритет для браузеров, логгер должен оставаться полностью совместимым с node.

- Логи необходимо структурировать, поэтому логгер должен предоставлять именованные инстансы. Каждый инстанс должен иметь независимый уровень логгирования.

- API логгера должен быть минималистичным. В идеале это лишь конечные методы для отправки сообщений (info, error и т.п.), метод для получения именованного логгера, метод для изменения уровня логгера и метод для добавления плагинов.

### API

`log(name, level)` - получение именнованного логгера с заданным уровнем

`log.level` - геттер/сеттер уровня логгера

`log.use(plugin, props)` - добавление плагина / назначение ему новых свойств

`log.trace()`, `log.debug()`, `log.info()`, `log.warn()`, `log.error()` - методы для отправки логов

